/* low level upnp functions, utilizing V2*/

var LOGFILE_NAME = "sonos-controller.log";
var lWarn = {
		logln : function(o) {
		}
	};
	var lInfo = {
		logln : function(o) {
		}
	};


lInfo = new Logger(LOGFILE_NAME);
lWarn = new Logger(LOGFILE_NAME);

function getFirstActiveIP() {
	var oPlayerArray = Property.getNode('players').getChildren();
	for (var iIndex = 0; iIndex < oPlayerArray.length; iIndex++) {
		if (oPlayerArray[iIndex].getChild('online').getValue()==true)
			if (oPlayerArray[iIndex].getChild('invisible').getValue()==false)
				return oPlayerArray[iIndex].getChild('ip').getValue();
	}
	return null;
}


function encodeMetaData(metaData) {	
	metaData=metaData.replace(/&/g, '&amp;');
	metaData=metaData.replace(/</g, '&lt;');
	metaData=metaData.replace(/>/g, '&gt;');
	metaData=metaData.replace(/"/g, '&quot;');
	metaData=metaData.replace(/'/g, '&apos;');
	return metaData;
}


function decodeMetaData(metaData) {	
	metaData=metaData.replace( /&amp;/g , '&');
	metaData=metaData.replace(/&lt;/g,'<');
	metaData=metaData.replace(/&gt;/g,'>');
	metaData=metaData.replace(/&quot;/g,'"');
	metaData=metaData.replace(/&apos;/g, "'");
	return metaData;
}

function getPlayerIPAdress(playerID) {
	if (playerID==null)
		return null;
	var oPlayerArray=Property.getNode('players').getChildren();
	for (var iIndex=0;iIndex<oPlayerArray.length;iIndex++) {
		if (oPlayerArray[iIndex].getChild('id').getValue()==playerID)
			return oPlayerArray[iIndex].getChild('ip').getValue();
	}
	return null;
}

if (raisedEvent.parameter.actions!=null) {
	var playerIP;
	if (raisedEvent.parameter.player!=null)
		playerIP=getPlayerIPAdress(raisedEvent.parameter.player);
	
	switch (raisedEvent.parameter.actions) {
		case 'getSonosPlaylists': {
			upnpGetSonosPlaylists([getFirstActiveIP()]);
			break;
		}		
		case 'getSonosPlaylistsXML': {
			upnpGetSonosPlaylistsXML([getFirstActiveIP()]);
			break;
		}		
		case 'getSonosFavorites': {
			upnpGetSonosFavorites(getFirstActiveIP());
			break;
		}
		case 'getSonosGroups': {
			upnpGetSonosGroups(getFirstActiveIP());
			break;
		}
	}
	
	if (playerIP!=null) {
		switch (raisedEvent.parameter.actions) {
			case 'play': {
				upnpPlay(playerIP);
				break;
			}
			case 'pause': {
				upnpPause(playerIP);
				break;
			}
			case 'stop': {
				upnpStop(playerIP);
				break;
			}
			case 'getCurrentQueue': {
				upnpGetCurrentQueue(playerIP);
				break;
			}
			case 'getCurrentRadio': {
				upnpGetCurrentRadio(playerIP);
				break;
			}
			case 'getPositionInfo': {
				upnpGetPositionInfo(playerIP);
				break;
			}
			case 'getCurrentTrack': {
				upnpGetCurrentTrack(playerIP);
				break;
			}
			case 'setContentSrc': {
				upnpSetContentSrc (playerIP, raisedEvent.parameter.contentSrc);
				break;
			}
			case 'setRadio': {
				upnpSetRadio(playerIP, raisedEvent.parameter.contentSrc, raisedEvent.parameter.title);
				break;
			}
			case 'clearQueue': {
				upnpClearQueue(playerIP);
				break;
			}
			case 'loadPlaylist': {
				var sMeta=(unescape(raisedEvent.parameter.metaData));
				lInfo.logln('Metadata: ' + sMeta);
				var sUrl=encodeMetaData(unescape(raisedEvent.parameter.playlist));
				lInfo.logln('sUrl: ' + sUrl);
				upnpLoadPlaylist(playerIP, sUrl, sMeta);
				break;
			}
			case 'addURI': {
				var sMeta=encodeMetaData(unescape(raisedEvent.parameter.metaData));
				lInfo.logln('Metadata: ' + sMeta);
				var sUrl=encodeMetaData(unescape(raisedEvent.parameter.playlist));
				lInfo.logln('sUrl: ' + sUrl);
				upnpAddUriToQueue(playerIP, raisedEvent.parameter.queue, sUrl, sMeta);
				break;
			}
			case 'seek': {
				upnpSeek(playerIP, (raisedEvent.parameter.byTrack=='true'), raisedEvent.parameter.seekValue);
				break;
			}
			case 'getMute': {
				upnpGetMute(playerIP);
				break;
			}
			case 'setMute': {
				upnpSetMute(playerIP);
				break;
			}
			case 'setVolume': {
				upnpSetVolume(playerIP, raisedEvent.parameter.volume);
				break;
			}
			case 'getTransportInfo': {
				upnpGetTransportInfo(playerIP);
				break;
			}
			case 'getPositionInfo': {
				upnpGetPositionInfo(playerIP);
				break;
			}
			case 'getMediaInfo': {
				upnpGetMediaInfo(playerIP);
				break;
			}
			case 'getVolume': {
				upnpGetVolume(playerIP);
				break;
			}
			case 'setPlayMode': {
				upnpSetPlayMode(szIpAddressRenderer, raisedEvent.parameter.modeName);
				break;
			}
			case 'getPlayMode': {
				upnpGetPlayMode(playerIP);
				break;
			}
			case 'getSonosGroupID': {
				upnpGetSonosGroupID(playerIP, raisedEvent.parameter.deviceID);
				break;
			}
			case 'saveQueue': {
				upnpSaveQueue(playerIP, raisedEvent.parameter.title);
				break;
			}
			case 'deleteQueueFromList': {
				upnpDeleteQueueFromList(playerIP, raisedEvent.parameter.queueID);
				break;
			}
			case 'setPlayerAsStandAloneGroup': {
				upnpSetPlayerAsStandAloneGroup(playerIP);
				break;
			}
		}
	}
}